//Clase GrafoLista, que implementa un grafo con una lista enlazada
// o tal vez, no tan asi :). Esta muy adecuada al problema resuelto
// con Kruskal. Hay funciones o trozos de codigo que no se ocupan!

import java.io.*;
public class GrafoLista
{
	ListNodo L;	//donde guardaremos los nodos
	ListNodo[] Nodos; //lo usamos por motivos auxiliares
	String name;	//etiqueta
	Edge[] arcos;

	public GrafoLista(String nombre)throws IOException
	{
		//Constructor que lee una lista de adyacencia para construir un grafo
		BufferedReader entrada=new BufferedReader(new FileReader(nombre));
		
		String aux=entrada.readLine();
		Nodos=null; arcos=null;

		while(aux!=null)
		{
			ListNodo U=new ListNodo(aux.substring(0,aux.indexOf(' ')),null);

			if(Nodos==null){ L=U; name="G";}
			//agregamos U {al listado si no esta
			agregarNodoSiNoEsta(this,U);
			if(aux.indexOf(' ')>0)
			aux=aux.substring(aux.indexOf(' ')+1);
			
			while(aux.length()>0 && aux.indexOf(' ')>=0)
			{
			  ListNodo V=new ListNodo(aux.substring(0,aux.indexOf(' ')),null);
			  agregarNodoSiNoEsta(this,V);

			  if(aux.indexOf(' ')>0)
			  aux=aux.substring(aux.indexOf(' ')+1);
			  String aux2;
			  if(aux.indexOf(' ')<0)
				aux2=aux;
			  else
		         {		
				aux2=aux.substring(0,aux.indexOf(' '));
				aux=aux.substring(aux2.indexOf(' ')+1);
			 }	
			  
			  Edge UV=new Edge(U,V,Double.parseDouble(aux2));
			  agregarArcoSiNoEsta(this,UV); 
			  
			  if(aux.indexOf(' ')>0)
			  aux=aux.substring(aux.indexOf(' ')+1);
			}

			aux=entrada.readLine();
		}
		
	}
	public void agregarNodoSiNoEsta(GrafoLista X, ListNodo U)
	{
		if(X.Nodos==null)
                        {
                                X.Nodos=new ListNodo[1]; X.Nodos[0]=U;
                        }
                        else
                        {       boolean esta=false;
                                for(int i=0; i<X.Nodos.length; i++)
                                        if(X.Nodos[i].equals(U))
                                        { esta=true; i=X.Nodos.length;    }
                                if(!esta)
                                {
                                        ListNodo[] NodosAux=new ListNodo[X.Nodos.length+1];
                                        for(int i=0; i<X.Nodos.length; i++)
                                                NodosAux[i]=X.Nodos[i];
                                        NodosAux[X.Nodos.length]=U;
                                        X.Nodos=NodosAux;
                                }
                        }
	}
	public void agregarArcoSiNoEsta(GrafoLista X,Edge U)
	{
		if(X.arcos==null)
                        {
                                X.arcos=new Edge[1]; X.arcos[0]=U;
                        }
                        else
                        {       boolean esta=false;
                                for(int i=0; i<X.arcos.length; i++)
			         if(X.arcos[i].compare(U))
                                        { esta=true; i=X.arcos.length;    }
                                
				if(!esta)
                                {
                                        Edge[] arcosAux=new Edge[X.arcos.length+1];
                                        for(int i=0; i<X.arcos.length; i++)
                                                arcosAux[i]=X.arcos[i];
                                        arcosAux[X.arcos.length]=U;
                                        X.arcos=arcosAux;
                                }
                        }
	}
	public GrafoLista(ListNodo X, String nombre)
	{
		//Construye un grafo con un solo nodo
		L=X;
		Nodos=null; arcos=null;
		name=nombre;
	}
	public GrafoLista(ListNodo X, ListNodo[] Y)
	{
		L=X; Nodos=Y; arcos=null;
		name=X.elemento;
	}
	public GrafoLista(ListNodo X)
	{
		L=X; Nodos=new ListNodo[1]; Nodos[0]=X; arcos=null; name=X.elemento;
	}
	
	public String FindSet()
	{	return L.padre.elemento; /*la etiqueta del padre es el nombre*/	}

	public GrafoLista Union(GrafoLista X)
	{
		GrafoLista Grande, Chico;
		if(this.Nodos==null && X.Nodos==null)
		{
			Grande=this; Chico=X;
		}
		else if(this.Nodos==null)
		{
			Grande=X; Chico=this;
		}
		else if(X.Nodos==null)
		{
			Grande=this; Chico=X;
		}
		else if(this.Nodos.length<X.Nodos.length)
		{	Grande=X; Chico=this;	}
		else
		{	Grande=this; Chico=X;	}
	
		//hacemos al padre del mas chico, hijo del padre del mas grande
		Grande.L.addNodo(Chico.L);
		agregarNodoSiNoEsta(Grande,Chico.L);
		Chico.L.padre=Grande.L;

		//agregamos los nodos del chico al grande y hacemos que todos ellos tengan nuevo padre
		if(Chico.Nodos!=null)
		for(int i=0; i<Chico.Nodos.length; i++)
		{	Chico.Nodos[i].padre=Grande.L;
			agregarNodoSiNoEsta(Grande,Chico.Nodos[i]);	
		}
		
		//agregamos los arcos
		if(Chico.arcos!=null)
		for(int i=0; i<Chico.arcos.length; i++)
			agregarArcoSiNoEsta(Grande,Chico.arcos[i]);
		return Grande;
	}

	public String toString()
	{
		String aux="";
		for(int i=0; i<this.arcos.length; i++)
			aux+=this.arcos[i].nodoU.elemento+" "+this.arcos[i].nodoV.elemento+" "+this.arcos[i].peso+"\n";
		return aux;
	}
}
