//clase que implementa el algoritmo de Kruskal
//Se ejecuta como:
//java myKruskal archivo.txt 
//con archivo.txt, el grafo codificacdo como se muestra en el archivo prueba01.txt
//Los resultados se imprimen en pantalla
import java.io.*;
import java.util.*;
class myKruskal
{
	
	static public void main(String[]args)throws IOException
	{
		String nombreArchivo=args[0];
		
		GrafoLista G=new GrafoLista(nombreArchivo);

		//algoritmo

		System.out.println("El Grafo G:");
		System.out.println(G.toString());
		Edge[] H=Kruskal(G);
		System.out.println("El arbol generador de peso minimo:");
		System.out.println(EdgeToString(H));
		double total=0;
		for(int i=0; i<H.length; i++)
			total+=H[i].peso;
		System.out.println("Costo: "+total);
	}

	static private Edge[] Kruskal(GrafoLista G) //la funcion de peso viene implicita en la estructura
	{
		//ordenamos los arcos
		System.out.println("Los arcos ordenados:");
		Sort(G.arcos);
		System.out.println(G.toString());
		Hashtable hash=new Hashtable();
		Edge[] H=null;
		for(int i=0; i<G.arcos.length; i++) 
		{
			GrafoLista izq, der;
			if(!hash.containsKey(G.arcos[i].nodoU.elemento))
			{	izq=new GrafoLista(G.arcos[i].nodoU);
				hash.put(G.arcos[i].nodoU.elemento,izq);
			}
			else{	izq=(GrafoLista)hash.get(G.arcos[i].nodoU.elemento);
			}if(!hash.containsKey(G.arcos[i].nodoV.elemento))
			{       der=new GrafoLista(G.arcos[i].nodoV);
				hash.put(G.arcos[i].nodoV.elemento,der);
			}
			else{ der=(GrafoLista)hash.get(G.arcos[i].nodoV.elemento);
			}
		}
		int maxArcos=G.Nodos.length-1;

		for(int i=0; i<G.arcos.length && (H==null||H.length<=maxArcos) ; i++)
		{
			if(!((GrafoLista)hash.get(G.arcos[i].nodoU.elemento)).FindSet().equals(((GrafoLista)hash.get(G.arcos[i].nodoV.elemento)).FindSet()))
			{
				H=agregarArco(H,G.arcos[i]);
				GrafoLista L1=(GrafoLista)(hash.get(G.arcos[i].nodoU.elemento));
				GrafoLista L2=(GrafoLista)hash.get(G.arcos[i].nodoV.elemento);
				L1=L1.Union(L2);
				hash.put(G.arcos[i].nodoU.elemento,L1); hash.put(G.arcos[i].nodoV.elemento,L1);
				
			}				
		}
		
		return H;
	}
	static private Edge[] agregarArco(Edge[] X,Edge U)
        {
                if(X==null)
                        {
                                X=new Edge[1]; X[0]=U;
                        	return X;
			}
                        else
                        {       
                                        Edge[] arcosAux=new Edge[X.length+1];
                                        for(int i=0; i<X.length; i++)
                                                arcosAux[i]=X[i];
                                        arcosAux[X.length]=U;
                                        X=arcosAux;
					return X;
                        }
	}

	static private void Sort(Edge[] X)
	{
		//immplementamos bubblesort
		int N=X.length;
		for(int i=0; i<N; i++)
   			for(int j=0; j<N-i-1; j++)
    				if(X[j+1].peso<X[j].peso)
        			{
					Edge tmp=X[j];
        				X[j]=X[j+1];
        				X[j+1]=tmp;
       				}
		 
	}
	static private String EdgeToString(Edge[] X)        
        {                               
                String aux="";  
                for(int i=0; i<X.length; i++)
                        aux+=X[i].nodoU.elemento+" "+X[i].nodoV.elemento+" "+X[i].peso+"\n";
                return aux;
        }
}
